<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch">
      <el-form-item :label="$t('page.system.role.name')+'：'" prop="roleName">
        <el-input
          v-model="queryParams.roleName"
          :placeholder="$t('form.placeholderInput')"
          clearable
          style="width: 240px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('page.system.role.key')+'：'" prop="roleKey">
        <el-input
          v-model="queryParams.roleKey"
          :placeholder="$t('form.placeholderInput')"
          clearable
          style="width: 240px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('page.system.role.status')+'：'" prop="status">
        <el-select
          v-model="queryParams.status"
          :placeholder="$t('form.placeholderSelect')"
          clearable
          style="width: 240px"
        >
          <el-option key="0" :label="$t('page.system.role.statusEnable')" value="0" />
          <el-option key="1" :label="$t('page.system.role.statusDisable')" value="1" />
        </el-select>
      </el-form-item>
      <!-- <el-form-item label="创建时间">
        <el-date-picker
          v-model="dateRange"
          style="width: 240px"
          value-format="yyyy-MM-dd"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
        ></el-date-picker>
      </el-form-item> -->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{$t('form.search')}}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{$t('form.reset')}}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
         
          @click="handleAdd"
          v-hasPermi="['system:role:add']"
        >{{$t('form.add')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
         
          @click="handleExport"
          v-hasPermi="['system:role:export']"
        >{{$t('form.export')}}</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
         
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:role:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
         
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:role:remove']"
        >删除</el-button>
      </el-col>
      
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar> -->
    </el-row>

    <el-table v-loading="loading" :data="roleList" @selection-change="handleSelectionChange">
      <!-- <el-table-column type="selection" width="55" align="center" /> -->
      <!-- <el-table-column label="角色编号" prop="roleId" width="120" /> -->
      <el-table-column :label="$t('page.system.role.name')" prop="roleName" :show-overflow-tooltip="true" width="250" />
      <el-table-column :label="$t('page.system.role.key')" prop="roleKey" :show-overflow-tooltip="true" width="250" />
      <el-table-column :label="$t('page.system.role.remark')" prop="remark" :show-overflow-tooltip="true" />
      <!-- <el-table-column label="显示顺序" prop="roleSort" width="100" /> -->
      <el-table-column :label="$t('page.system.role.status')" prop="status" :show-overflow-tooltip="true" width="150">
        <template slot-scope="scope">
          <span v-if="scope.row.status==='0'">{{$t('page.system.role.statusEnable')}}</span>
          <span v-if="scope.row.status==='1'">{{$t('page.system.role.statusDisable')}}</span>
        </template>
      </el-table-column>
      <!-- <el-table-column label="状态" align="center" width="100">
        <template slot-scope="scope">
          <el-switch
            v-model="scope.row.status"
            active-value="0"
            inactive-value="1"
            @change="handleStatusChange(scope.row)"
          ></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column> -->
      <el-table-column :label="$t('form.operate')" align="center" class-name="small-padding fixed-width" width="200">
        <template slot-scope="scope" v-if="scope.row.roleId !== 1">
          <el-button
           
            type="text"
            @click="handleUpdate(scope.row,false)"
            v-hasPermi="['system:role:edit']"
          >{{$t('page.system.role.edit')}}</el-button>

          <el-button
           
            type="text"
            @click="handleStatusChange(scope.row)"
            v-hasPermi="['system:role:enable']"
            v-if="scope.row.status==='0'"
          >{{$t('page.system.role.disable')}}</el-button>

          <el-button
           
            type="text"
            @click="handleStatusChange(scope.row)"
            v-hasPermi="['system:role:enable']"
            v-if="scope.row.status==='1'"
          >{{$t('page.system.role.enable')}}</el-button>

          <el-button
           
            type="text"
            @click="transfer(scope.row)"
            v-hasPermi="['system:role:allocate']"
          >{{$t('page.system.role.allocate')}}</el-button>

          <el-button
           v-hasPermi="['system:role:detail']"
            type="text"
            @click="handleUpdate(scope.row,true)"
          >{{$t('page.system.role.detail')}}</el-button>

          <!-- <el-button
           
            type="text"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:role:remove']"
          >删除</el-button>
          <el-dropdown @command="(command) => handleCommand(command, scope.row)" v-hasPermi="['system:role:edit']">
            <el-button type="text" icon="el-icon-d-arrow-right">更多</el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="handleDataScope" icon="el-icon-circle-check"
                v-hasPermi="['system:role:edit']">数据权限</el-dropdown-item>
              <el-dropdown-item command="handleAuthUser" icon="el-icon-user"
                v-hasPermi="['system:role:edit']">分配用户</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown> -->

          <!-- <el-dropdown @command="(command) => handleCommand(command, scope.row)" v-hasPermi="['system:role:edit']">
            <el-button type="text" icon="el-icon-d-arrow-right">更多</el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="handleDataScope" icon="el-icon-circle-check"
                v-hasPermi="['system:role:edit']">数据权限</el-dropdown-item>
              <el-dropdown-item command="handleAuthUser" icon="el-icon-user"
                v-hasPermi="['system:role:edit']">分配用户</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown> -->
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改角色配置对话框 -->
    <el-dialog :close-on-click-modal="false" :close-on-press-escape="false" :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="150px">
        <el-form-item :label="$t('page.system.role.name')+'：'" prop="roleName">
          <el-input v-model="form.roleName" :placeholder="$t('form.placeholderInput')" :readonly="readonly" />
        </el-form-item>
        <el-form-item prop="roleKey">
          <span slot="label">
            <!-- <el-tooltip content="控制器中定义的权限字符，如：@PreAuthorize(`@ss.hasRole('admin')`)" placement="top">
              <i class="el-icon-question"></i>
            </el-tooltip> -->
            {{$t('page.system.role.key')}}：
          </span>
          <el-input v-model="form.roleKey" :placeholder="$t('form.placeholderInput')" :readonly="readonly" />
        </el-form-item>
        <!-- <el-form-item label="角色顺序" prop="roleSort">
          <el-input-number v-model="form.roleSort" controls-position="right" :min="0" />
        </el-form-item> -->
        <el-form-item :label="$t('page.system.role.status')+'：'" prop="status">
          <el-select
            v-model="form.status"
            :placeholder="$t('form.placeholderSelect')"
            style="width:100%"
            :disabled="readonly"
          >
            <el-option key="0" :label="$t('page.system.role.statusEnable')" value="0" />
            <el-option key="1" :label="$t('page.system.role.statusDisable')" value="1" />
          </el-select>

        </el-form-item>
         <el-form-item :label="$t('page.system.role.remark')+'：'">
          <el-input v-model="form.remark" type="textarea" :placeholder="$t('form.placeholderSelect')" :readonly="readonly"></el-input>
        </el-form-item>
        <el-form-item :label="$t('page.system.role.permit')+'：'">
          <!-- <el-checkbox v-model="menuExpand" @change="handleCheckedTreeExpand($event, 'menu')">展开/折叠</el-checkbox>
          <el-checkbox v-model="menuNodeAll" @change="handleCheckedTreeNodeAll($event, 'menu')">全选/全不选</el-checkbox>
          <el-checkbox v-model="form.menuCheckStrictly" @change="handleCheckedTreeConnect($event, 'menu')">父子联动</el-checkbox> -->
          <el-tree
            class="tree-border"
            :data="menuOptions"
            show-checkbox
            ref="menu"
            node-key="id"
            :check-strictly="false"
            empty-text="loading"
            :props="defaultProps"
          ></el-tree>
        </el-form-item>
       
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!readonly">
        <el-button type="primary" @click="submitForm">{{$t('form.saveConfirm')}}</el-button>
        <el-button @click="cancel">{{$t('form.cancel')}}</el-button>
      </div>
    </el-dialog>

    <!-- 分配角色数据权限对话框 -->
    <el-dialog :close-on-click-modal="false" :close-on-press-escape="false" :title="title" :visible.sync="openDataScope" width="500px" append-to-body>
      <el-form :model="form" label-width="80px">
        <el-form-item label="角色名称">
          <el-input v-model="form.roleName" :disabled="true" />
        </el-form-item>
        <el-form-item label="权限字符">
          <el-input v-model="form.roleKey" :disabled="true" />
        </el-form-item>
        <el-form-item label="权限范围">
          <el-select v-model="form.dataScope" @change="dataScopeSelectChange">
            <el-option
              v-for="item in dataScopeOptions"
              :key="item.value"
              :label="item.label"
              :value="item.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="数据权限" v-show="form.dataScope == 2">
          <el-checkbox v-model="deptExpand" @change="handleCheckedTreeExpand($event, 'dept')">展开/折叠</el-checkbox>
          <el-checkbox v-model="deptNodeAll" @change="handleCheckedTreeNodeAll($event, 'dept')">全选/全不选</el-checkbox>
          <el-checkbox v-model="form.deptCheckStrictly" @change="handleCheckedTreeConnect($event, 'dept')">父子联动</el-checkbox>
          <el-tree
            class="tree-border"
            :data="deptOptions"
            show-checkbox
            default-expand-all
            ref="dept"
            node-key="id"
            :check-strictly="!form.deptCheckStrictly"
            empty-text="加载中，请稍候"
            :props="defaultProps"
          ></el-tree>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitDataScope">确 定</el-button>
        <el-button @click="cancelDataScope">取 消</el-button>
      </div>
    </el-dialog>


    <!-- 分配角色数据权限对话框 -->
    <el-dialog :close-on-click-modal="false" :close-on-press-escape="false" :title="transferDialog.title" :visible.sync="transferDialog.visible" width="750px" append-to-body>
      <el-transfer class="role-transfer" v-model="transferDialog.selected" :data="transferDialog.list" :titles="[$t('page.system.role.unauthorized'), $t('page.system.role.authorized')]"
        filterable
        :filter-method="filterMethod"
        :filter-placeholder="$t('page.system.role.filterPlaceholder')">
      </el-transfer>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="changRoleUser">{{$t('form.saveConfirm')}}</el-button>
        <el-button @click="transferDialog.visible = false">{{$t('form.cancel')}}</el-button>
      </div>
    </el-dialog>

    <Sign ref="signRef" @callback="doChangRoleUser" />
  </div>
</template>

<script>
import { listRole, getRole, delRole, addRole, updateRole, dataScope, changeRoleStatus, deptTreeSelect,allocatedUserList,authUserSetAll } from "@/api/system/role"
import { treeselect as menuTreeselect, roleMenuTreeselect } from "@/api/system/menu"
import Sign from '@/views/business/study/comp/sign.vue'

export default {
  name: "Role",
  dicts: ['sys_normal_disable'],
  components:{Sign},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 角色表格数据
      roleList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 是否显示弹出层（数据权限）
      openDataScope: false,
      menuExpand: false,
      menuNodeAll: false,
      deptExpand: true,
      deptNodeAll: false,
      // 日期范围
      dateRange: [],
      // 数据范围选项
      dataScopeOptions: [
        {
          value: "1",
          label: "全部数据权限"
        },
        {
          value: "2",
          label: "自定数据权限"
        },
        {
          value: "3",
          label: "本部门数据权限"
        },
        {
          value: "4",
          label: "本部门及以下数据权限"
        },
        {
          value: "5",
          label: "仅本人数据权限"
        }
      ],
      // 菜单列表
      menuOptions: [],
      // 部门列表
      deptOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        roleName: undefined,
        roleKey: undefined,
        status: undefined
      },
      // 表单参数
      form: {},
      defaultProps: {
        children: "children",
        label: "label"
      },
      // 表单校验
      rules: {
        roleName: [
          { required: true, message: this.$t('form.placeholderInput'), trigger: "blur" }
        ],
        roleKey: [
          { required: true, message: this.$t('form.placeholderInput'), trigger: "blur" }
        ],
        status: [
          { required: true, message: this.$t('form.placeholderSelect'), trigger: "change" }
        ],
      },

      readonly:false,
      
      transferDialog:{
        title:this.$t('page.system.role.allocate'),
        visible:false,
        
        list:[],
        selected:[],
        roleId:'',

        oldIdList:[]

      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询角色列表 */
    getList() {
      this.loading = true
      listRole(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
          this.roleList = response.rows
          this.total = response.total
          this.loading = false
        }
      )
    },
    /** 查询菜单树结构 */
    getMenuTreeselect() {
      menuTreeselect().then(response => {
        this.menuOptions = response.data
      })
    },
    // 所有菜单节点数据
    getMenuAllCheckedKeys() {
      // 目前被选中的菜单节点
      let checkedKeys = this.$refs.menu.getCheckedKeys()
      // 半选中的菜单节点
      let halfCheckedKeys = this.$refs.menu.getHalfCheckedKeys()
      checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys)
      return checkedKeys
    },
    // 所有部门节点数据
    getDeptAllCheckedKeys() {
      // 目前被选中的部门节点
      let checkedKeys = this.$refs.dept.getCheckedKeys()
      // 半选中的部门节点
      let halfCheckedKeys = this.$refs.dept.getHalfCheckedKeys()
      checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys)
      return checkedKeys
    },
    /** 根据角色ID查询菜单树结构 */
    getRoleMenuTreeselect(roleId) {
      return roleMenuTreeselect(roleId).then(response => {
        this.menuOptions = response.menus
        this.setDisabled(this.menuOptions)
        return response
      })
    },
    setDisabled(arr) {
      for (var i = 0; i < arr.length; i++) {
        arr[i]['disabled'] = this.readonly
        if (arr[i].children && arr[i].children.length > 0) {
          this.setDisabled(arr[i].children)
        }
      }
    },
    /** 根据角色ID查询部门树结构 */
    getDeptTree(roleId) {
      return deptTreeSelect(roleId).then(response => {
        this.deptOptions = response.depts
        return response
      })
    },
    // 角色状态修改
    handleStatusChange(row) {
      changeRoleStatus(row.roleId, row.status === "0"?'1':'0').then(response => {
        this.getList()
      })

      // let text = row.status === "0" ? "启用" : "停用"
      // this.$modal.confirm('确认要"' + text + '""' + row.roleName + '"角色吗？').then(function() {
      //   return changeRoleStatus(row.roleId, row.status)
      // }).then(() => {
      //   this.$modal.msgSuccess(text + "成功")
      // }).catch(function() {
      //   row.status = row.status === "0" ? "1" : "0"
      // })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 取消按钮（数据权限）
    cancelDataScope() {
      this.openDataScope = false
      this.reset()
    },
    // 表单重置
    reset() {
      if (this.$refs.menu != undefined) {
        this.$refs.menu.setCheckedKeys([])
      }
      this.menuExpand = false,
      this.menuNodeAll = false,
      this.deptExpand = true,
      this.deptNodeAll = false,
      this.form = {
        roleId: undefined,
        roleName: undefined,
        roleKey: undefined,
        roleSort: 0,
        status: "0",
        menuIds: [],
        deptIds: [],
        menuCheckStrictly: true,
        deptCheckStrictly: true,
        remark: undefined
      }
      this.resetForm("form")
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = []
      this.resetForm("queryForm")
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.roleId)
      this.single = selection.length!=1
      this.multiple = !selection.length
    },
    // 更多操作触发
    handleCommand(command, row) {
      switch (command) {
        case "handleDataScope":
          this.handleDataScope(row)
          break
        case "handleAuthUser":
          this.handleAuthUser(row)
          break
        default:
          break
      }
    },
    // 树权限（展开/折叠）
    handleCheckedTreeExpand(value, type) {
      if (type == 'menu') {
        let treeList = this.menuOptions
        for (let i = 0; i < treeList.length; i++) {
          this.$refs.menu.store.nodesMap[treeList[i].id].expanded = value
        }
      } else if (type == 'dept') {
        let treeList = this.deptOptions
        for (let i = 0; i < treeList.length; i++) {
          this.$refs.dept.store.nodesMap[treeList[i].id].expanded = value
        }
      }
    },
    // 树权限（全选/全不选）
    handleCheckedTreeNodeAll(value, type) {
      if (type == 'menu') {
        this.$refs.menu.setCheckedNodes(value ? this.menuOptions: [])
      } else if (type == 'dept') {
        this.$refs.dept.setCheckedNodes(value ? this.deptOptions: [])
      }
    },
    // 树权限（父子联动）
    handleCheckedTreeConnect(value, type) {
      if (type == 'menu') {
        this.form.menuCheckStrictly = value ? true: false
      } else if (type == 'dept') {
        this.form.deptCheckStrictly = value ? true: false
      }
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.readonly = false
      this.reset()
      this.getMenuTreeselect()
      this.open = true
      this.title = this.$t('page.system.role.addRole')
      
    },
    /** 修改按钮操作 */
    handleUpdate(row,readonly) {
      this.readonly = readonly
      if(readonly){
        this.saveSimpleLog({name:row.roleName,nameEn:row.roleName,jcmc:'角色详情',jcmcEn:'Role Detail'})
      }
      this.reset()
      const roleId = row.roleId || this.ids
      const roleMenu = this.getRoleMenuTreeselect(roleId)
      getRole(roleId).then(response => {
        this.form = response.data
        this.open = true
        this.$nextTick(() => {
          roleMenu.then(res => {
            let checkedKeys = res.checkedKeys
            checkedKeys.forEach((v) => {
                this.$nextTick(()=>{
                    this.$refs.menu.setChecked(v, true ,false)
                })
            })
          })
        })
      })
      this.title = this.$t('page.system.role.modifyRole')
    },
    /** 选择角色权限范围触发 */
    dataScopeSelectChange(value) {
      if(value !== '2') {
        this.$refs.dept.setCheckedKeys([])
      }
    },
    /** 分配数据权限操作 */
    handleDataScope(row) {
      this.reset()
      const deptTreeSelect = this.getDeptTree(row.roleId)
      getRole(row.roleId).then(response => {
        this.form = response.data
        this.openDataScope = true
        this.$nextTick(() => {
          deptTreeSelect.then(res => {
            this.$refs.dept.setCheckedKeys(res.checkedKeys)
          })
        })
      })
      this.title = "分配数据权限"
    },
    /** 分配用户操作 */
    handleAuthUser: function(row) {
      const roleId = row.roleId
      this.$router.push("/system/role-auth/user/" + roleId)
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.$modal.loading()
          if (this.form.roleId != undefined) {
            this.form.menuIds = this.getMenuAllCheckedKeys()
            updateRole(this.form).then(response => {
              this.open = false
              this.getList()
            }).finally(()=>{
              this.$modal.closeLoading()
            })
          } else {
            this.form.menuIds = this.getMenuAllCheckedKeys()
            addRole(this.form).then(response => {
              this.open = false
              this.getList()
            }).finally(()=>{
              this.$modal.closeLoading()
            })
          }
        }
      })
    },
    /** 提交按钮（数据权限） */
    submitDataScope: function() {
      if (this.form.roleId != undefined) {
        this.form.deptIds = this.getDeptAllCheckedKeys()
        dataScope(this.form).then(response => {
          this.$modal.msgSuccess("修改成功")
          this.openDataScope = false
          this.getList()
        })
      }
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const roleIds = row.roleId || this.ids
      this.$modal.confirm(this.$t('form.confirmDelete')).then(function() {
        return delRole(roleIds)
      }).then(() => {
        this.getList()
      }).catch(() => {})
    },
    /** 导出按钮操作 */
    handleExport() {
      this.saveSimpleLog({name:'',nameEn:'',jcmc:'角色导出',jcmcEn:'Role Export'})
      this.download('system/role/export', {
        ...this.queryParams
      }, `role_${new Date().getTime()}.xlsx`)
    },

    transfer(row){
      allocatedUserList({roleId:row.roleId}).then(response => {
          let list = []
          _.forEach(response.list,(item)=>{
            list.push({
              key:item.userId,
              label:`${item.nickName}(${item.userName})`
            })
          })
          this.transferDialog.selected = response.selected
          this.transferDialog.list = list
          this.transferDialog.roleId = row.roleId

          this.transferDialog.oldIdList = _.cloneDeep(response.selected)
          this.transferDialog.visible = true
        }
      )
    },
    filterMethod(query, item){
      return item.label.indexOf(query) > -1;
    },
    changRoleUser(){
      let update = false
      let userIdList = this.transferDialog.selected && this.transferDialog.selected.length>0 ? this.transferDialog.selected:[]
      if(this.transferDialog.oldIdList.length!==userIdList.length){
        update = true
      }else{
        for(let i=0;i<this.transferDialog.oldIdList.length;i++){
          if(_.findIndex(userIdList,o=>{return o===this.transferDialog.oldIdList[i]})==-1){
            update = true
            break
          }
        }
      }
      if(update){
        this.$refs.signRef.show(
          this.$t('page.system.role.fpjs'),
          this.$t('page.system.role.fpjs'),
        )
      }else{
        this.transferDialog.visible = false
      }
    },
    doChangRoleUser(sign){
      this.$modal.loading()
      authUserSetAll({ roleId: this.transferDialog.roleId, userIdList: this.transferDialog.selected && this.transferDialog.selected.length>0 ? this.transferDialog.selected:[] ,sign:sign}).then(res => {
        this.$refs.signRef.cancel()
        this.transferDialog.visible = false
      }).finally(()=>{
        this.$modal.closeLoading()
      })
    }
  }
}
</script>
<style lang="scss">
.role-transfer{
  .el-transfer-panel{
    width: 250px;
  }
}

</style>